image: gradle:6.8.3-jdk11

stages:
  - build
  - test
  - release

services:
  - docker:19.03.1-dind

variables:
  DOCKER_HOST: tcp://docker:2376
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: "/certs"
  # Used for Gradle Docker plugin
  DOCKER_CERT_PATH: "/certs/client"
  DOCKER_TLS_VERIFY: "true"

  GRADLE_OPTS: "-Dorg.gradle.daemon=false"

before_script:
  - export GRADLE_USER_HOME=/cache/.gradle
  - mkdir -p $HOME/.docker/
  - echo "$CONFIG_JSON" > "$HOME/.docker/config.json"

build:
  services: []
  stage: build
  script:
    - gradle --build-cache --parallel clean assemble testClasses
  except:
    variables:
      - $RELEASE_VERSION

test:
  stage: test
  variables:
    DOCKER_HOSTNAME: docker
  script:
    - gradle --build-cache test
  artifacts:
    paths:
      - "*/build/test-results/*/TEST-*.xml"
    reports:
      junit:
        - "*/build/test-results/*/TEST-*.xml"
  except:
    variables:
      - $RELEASE_VERSION

release:
  stage: release
  variables:
    IMAGE_NAME: docker.nexus.dataspac.es/federated-learning/data-app
    IMAGE_TAG: $CI_COMMIT_REF_NAME
  script:
    - gradle --build-cache jib
  except:
    variables:
      - $RELEASE_VERSION
    
release_version:
  stage: release
  variables:
    IMAGE_NAME: docker.nexus.dataspac.es/federated-learning/data-app
    IMAGE_TAG: $RELEASE_VERSION
  script:
    - gradle --build-cache jib
  only:
    variables:
      - $RELEASE_VERSION
    